#ifndef EFL_GFX_IMAGE_ANIMATION_CONTROLLER_EO_HH
#define EFL_GFX_IMAGE_ANIMATION_CONTROLLER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx_image_animation_controller.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_GFX_IMAGE_ANIMATION_CONTROLLER_FWD_GUARD
#define EFL_GFX_IMAGE_ANIMATION_CONTROLLER_FWD_GUARD
namespace efl { namespace gfx { 
struct Image_Animation_Controller;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Image_Animation_Controller> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Image_Animation_Controller&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Image_Animation_Controller const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::gfx::Image_Animation_Controller const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace gfx { 
struct Image_Animation_Controller {
   ::efl::eolian::return_traits<bool>::type animated_get() const;
   ::efl::eolian::return_traits<int>::type animated_frame_get() const;
   ::efl::eolian::return_traits<bool>::type animated_frame_set( ::efl::eolian::in_traits<int>::type frame_index) const;
   ::efl::eolian::return_traits<int>::type animated_frame_count_get() const;
   ::efl::eolian::return_traits<Efl_Gfx_Image_Animation_Controller_Loop_Hint>::type animated_loop_type_get() const;
   ::efl::eolian::return_traits<int>::type animated_loop_count_get() const;
   ::efl::eolian::return_traits<double>::type animated_frame_duration_get( ::efl::eolian::in_traits<int>::type start_frame,  ::efl::eolian::in_traits<int>::type frame_num) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_GFX_IMAGE_ANIMATION_CONTROLLER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Image_Animation_Controller *>(this))); }
   operator ::efl::gfx::Image_Animation_Controller() const;
   operator ::efl::gfx::Image_Animation_Controller&();
   operator ::efl::gfx::Image_Animation_Controller const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Image_Animation_Controller> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Image_Animation_Controller const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace gfx { 
struct Image_Animation_Controller : private ::efl::eo::concrete
{
   explicit Image_Animation_Controller( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Image_Animation_Controller(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Image_Animation_Controller() = default;
   Image_Animation_Controller(Image_Animation_Controller const&) = default;
   Image_Animation_Controller(Image_Animation_Controller&&) = default;
   Image_Animation_Controller& operator=(Image_Animation_Controller const&) = default;
   Image_Animation_Controller& operator=(Image_Animation_Controller&&) = default;
   template <typename Derived>
   Image_Animation_Controller(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Image_Animation_Controller, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<bool>::type animated_get() const;
   ::efl::eolian::return_traits<int>::type animated_frame_get() const;
   ::efl::eolian::return_traits<bool>::type animated_frame_set( ::efl::eolian::in_traits<int>::type frame_index) const;
   ::efl::eolian::return_traits<int>::type animated_frame_count_get() const;
   ::efl::eolian::return_traits<Efl_Gfx_Image_Animation_Controller_Loop_Hint>::type animated_loop_type_get() const;
   ::efl::eolian::return_traits<int>::type animated_loop_count_get() const;
   ::efl::eolian::return_traits<double>::type animated_frame_duration_get( ::efl::eolian::in_traits<int>::type start_frame,  ::efl::eolian::in_traits<int>::type frame_num) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_GFX_IMAGE_ANIMATION_CONTROLLER_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Image_Animation_Controller *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Image_Animation_Controller> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Image_Animation_Controller const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Image_Animation_Controller> _get_wref() const { return ::efl::eo::wref<Image_Animation_Controller>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Image_Animation_Controller* operator->() const { return this; }
   Image_Animation_Controller* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Image_Animation_Controller const& lhs, Image_Animation_Controller const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Image_Animation_Controller const& lhs, Image_Animation_Controller const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Image_Animation_Controller) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Image_Animation_Controller>::value, "");
} } 
#endif
