#ifndef EFL_UI_RANGE_EO_HH
#define EFL_UI_RANGE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_range.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_UI_RANGE_FWD_GUARD
#define EFL_UI_RANGE_FWD_GUARD
namespace efl { namespace ui { 
struct Range;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Range> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Range&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Range const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Range const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Range {
   ::efl::eolian::return_traits<double>::type range_value_get() const;
   ::efl::eolian::return_traits<void>::type range_value_set( ::efl::eolian::in_traits<double>::type val) const;
   ::efl::eolian::return_traits<void>::type range_min_max_get( ::efl::eolian::out_traits<double>::type min,  ::efl::eolian::out_traits<double>::type max) const;
   ::efl::eolian::return_traits<void>::type range_min_max_set( ::efl::eolian::in_traits<double>::type min,  ::efl::eolian::in_traits<double>::type max) const;
   ::efl::eolian::return_traits<double>::type range_step_get() const;
   ::efl::eolian::return_traits<void>::type range_step_set( ::efl::eolian::in_traits<double>::type step) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_RANGE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Range *>(this))); }
   operator ::efl::ui::Range() const;
   operator ::efl::ui::Range&();
   operator ::efl::ui::Range const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Range> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Range const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Range : private ::efl::eo::concrete
{
   explicit Range( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Range(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Range() = default;
   Range(Range const&) = default;
   Range(Range&&) = default;
   Range& operator=(Range const&) = default;
   Range& operator=(Range&&) = default;
   template <typename Derived>
   Range(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Range, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<double>::type range_value_get() const;
   ::efl::eolian::return_traits<void>::type range_value_set( ::efl::eolian::in_traits<double>::type val) const;
   ::efl::eolian::return_traits<void>::type range_min_max_get( ::efl::eolian::out_traits<double>::type min,  ::efl::eolian::out_traits<double>::type max) const;
   ::efl::eolian::return_traits<void>::type range_min_max_set( ::efl::eolian::in_traits<double>::type min,  ::efl::eolian::in_traits<double>::type max) const;
   ::efl::eolian::return_traits<double>::type range_step_get() const;
   ::efl::eolian::return_traits<void>::type range_step_set( ::efl::eolian::in_traits<double>::type step) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_RANGE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Range *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Range> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Range const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Range> _get_wref() const { return ::efl::eo::wref<Range>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Range* operator->() const { return this; }
   Range* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Range const& lhs, Range const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Range const& lhs, Range const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Range) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Range>::value, "");
} } 
#endif
